/**
 * Rick van der Zwet <info@rickvanderzwet.nl>
 * Licence: BSD
 * UDP handshake taken from http://www.abc.se/~m6695/udp.html
 */

#include "timediff.h"

void diep(char *s)
{
    perror(s);
    exit(1);
}

int main(int argc, char * argv[]) {
    printf("Size of .. %li\n", sizeof(uint32_t));
    printf("Size of .. %li\n", sizeof(struct timeval));
    struct timeval tv;
    struct tm *tm;

    struct sockaddr_in si_me, si_other;
    int s, i, slen=sizeof(si_other);
    char buf[BUFLEN];

    if ((s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP))==-1)
        diep("socket");

    memset((char *) &si_me, 0, sizeof(si_me));
    si_me.sin_family = AF_INET;
    si_me.sin_port = htons(PORT);
    si_me.sin_addr.s_addr = htonl(INADDR_ANY);
    if (bind(s, (struct sockaddr *)&si_me, sizeof(si_me))==-1)
        diep("bind");

    struct timeval_t packet;
    for (i=0; i<NPACK; i++) {
        if (recvfrom(s, &tv, sizeof(tv), 0, (struct sockaddr *)&si_other, &slen)==-1)
            diep("recvfrom()");
        gettimeofday(&tv,NULL);
	packet.tv_sec = tv.tv_sec;
	packet.tv_usec = tv.tv_usec;
        if (sendto(s, (const void *)&packet, sizeof(packet), 0, (struct sockaddr *)&si_other, slen)==-1)
            diep("sendto()");
	printf("Send %i bytes\n", sizeof(packet));
        printf("Received packet from %s:%d\n", 
                inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
        tm=localtime(&tv.tv_sec);
        printf(" %d:%02d:%02d.%li \n", tm->tm_hour, tm->tm_min, tm->tm_sec, tv.tv_usec);
    }

    close(s);
    return 0;

    exit(0);
}
